using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	class AIPlayerRandom : IAIPlayer
	{
		public AIPlayerRandom(Game game, EPlayer player)
		{
			m_game = game;
			m_player = player;
		}

		#region IAIPlayer

		public void DoMove()
		{
			Random rand = new Random();
			List<IPiece> pieces = m_game.GetCurrentPieces(m_player);

			// Randomly select pieces and move the first one with a valid move
			while (pieces.Count > 0)
			{
				int i = rand.Next(pieces.Count);
				IPiece piece = pieces[i];

				if (piece.ValidMoves.Count > 0)
				{
					m_game.RequestMove(piece.ValidMoves[rand.Next(piece.ValidMoves.Count)]);
					break;
				}

				pieces.Remove(piece);
			}

			// No valid move available! Should not get to this point since this
			// condition should be spotted before allowing AI to do its move
		}
			

		#endregion // IAIPlayer

		#region Members

		private Game m_game;
		private EPlayer m_player;

		#endregion // Members
	}
}
