using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Chessticles
{
	public partial class NewGameForm : Form
	{
		#region Properties
		
		public Game.EPlayerType Player1Type
		{
			get { return m_ePlayer1Type; }
			set 
			{ 
				m_ePlayer1Type = value; 
				player1Human.Checked = (m_ePlayer1Type == Game.EPlayerType.Human);
				player1AI.Checked = (m_ePlayer1Type == Game.EPlayerType.AI);
			}
		}

		public Game.EPlayerType Player2Type
		{
			get { return m_ePlayer2Type; }
			set
			{
				m_ePlayer2Type = value;
				player2Human.Checked = (m_ePlayer2Type == Game.EPlayerType.Human);
				player2AI.Checked = (m_ePlayer2Type == Game.EPlayerType.AI);
			}
		}

		#endregion // Properties


		public NewGameForm()
		{
			m_ePlayer1Type = Game.EPlayerType.Human;
			m_ePlayer2Type = Game.EPlayerType.Human;
			InitializeComponent();
		}

		private void buttonStart_Click(object sender, EventArgs e)
		{
			m_ePlayer1Type = player1Human.Checked ? Game.EPlayerType.Human : Game.EPlayerType.AI;
			m_ePlayer2Type = player2Human.Checked ? Game.EPlayerType.Human : Game.EPlayerType.AI;
			DialogResult = DialogResult.OK;
			Close();
		}


		#region Members

		private Game.EPlayerType m_ePlayer1Type;
		private Game.EPlayerType m_ePlayer2Type;

		#endregion // Members

	}
}