﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	public class Bishop : Piece
	{
		public Bishop(GameModel model, EPlayer owner, Position pos)
			: base(model, EPieceType.Bishop, owner, pos)
		{	
		}

		public Bishop(Bishop piece)
			: base(piece)
		{
		}

		public Bishop(Pawn piece) // for Pawn Promotion
			: base(piece)
		{
			m_eType = EPieceType.Bishop;
		}

		public override Piece Clone()
		{
			return new Bishop(this);
		}

		public override void FindValidMoves(List<SMove> moves, int iDir)
		{
			// Test four diagonals
			FindStraightLineMoves(new Position(iDir, iDir), moves);
			FindStraightLineMoves(new Position(iDir, -iDir), moves);
			FindStraightLineMoves(new Position(-iDir, iDir), moves);
			FindStraightLineMoves(new Position(-iDir, -iDir), moves);
		}
	}
}
