﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	public class Knight : Piece
	{
		public Knight(GameModel model, EPlayer owner, Position pos)
			: base(model, EPieceType.Knight, owner, pos)
		{
		}

		public Knight(Knight piece)
			: base(piece)
		{
		}

		public Knight(Pawn piece) // for Pawn Promotion
			: base(piece)
		{
			m_eType = EPieceType.Knight;
		}

		public override Piece Clone()
		{
			return new Knight(this);
		}

		public override void FindValidMoves(List<SMove> moves, int iDir)
		{
			// Test the 8 possible moves
			Position[] positions = { new Position(m_position.row + 2*iDir, m_position.col - iDir),
															 new Position(m_position.row + 2*iDir, m_position.col + iDir),
															 new Position(m_position.row - 2*iDir, m_position.col - iDir),
															 new Position(m_position.row - 2*iDir, m_position.col + iDir),
															 new Position(m_position.row - iDir, m_position.col + 2*iDir),
															 new Position(m_position.row + iDir, m_position.col + 2*iDir),
															 new Position(m_position.row - iDir, m_position.col - 2*iDir),
															 new Position(m_position.row + iDir, m_position.col - 2*iDir)};
			foreach (Position p in positions)
			{
				if (p.IsValid() && m_model.GetPositionOwner(p) != m_eOwner)
				{
					moves.Add(new SMove(this, new Position(p.row, p.col)));
				}
			}
		}
	}
}
