﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	public class Queen : Piece
	{
		public Queen(GameModel model, EPlayer owner, Position pos)
			: base(model, EPieceType.Queen, owner, pos)
		{
		}

		public Queen(Queen piece)
			: base(piece)
		{
		}

		public Queen(Pawn piece) // for Pawn Promotion
			: base(piece)
		{
			m_eType = EPieceType.Queen;
		}

		public override Piece Clone()
		{
			return new Queen(this);
		}

		public override void FindValidMoves(List<SMove> moves, int iDir)
		{
			// Test four directions
			FindStraightLineMoves(new Position(0, iDir), moves);
			FindStraightLineMoves(new Position(0, -iDir), moves);
			FindStraightLineMoves(new Position(iDir, 0), moves);
			FindStraightLineMoves(new Position(-iDir, 0), moves);

			// Test four diagonals
			FindStraightLineMoves(new Position(iDir, iDir), moves);
			FindStraightLineMoves(new Position(iDir, -iDir), moves);
			FindStraightLineMoves(new Position(-iDir, iDir), moves);
			FindStraightLineMoves(new Position(-iDir, -iDir), moves);
		}
	}
}
