﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	public class Rook : Piece
	{
		public Rook(GameModel model, EPlayer owner, Position pos)
			: base(model, EPieceType.Rook, owner, pos)
		{
		}

		public Rook(Rook piece)
			: base(piece)
		{
		}

		public Rook(Pawn piece) // for Pawn Promotion
			: base(piece)
		{
			m_eType = EPieceType.Rook;
		}

		public override Piece Clone()
		{
			return new Rook(this);
		}

		public override void FindValidMoves(List<SMove> moves, int iDir)
		{
			// Test four directions
			FindStraightLineMoves(new Position(0, iDir), moves);
			FindStraightLineMoves(new Position(0, -iDir), moves);
			FindStraightLineMoves(new Position(iDir, 0), moves);
			FindStraightLineMoves(new Position(-iDir, 0), moves);
		}
	}
}
