﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Chessticles
{
	public class Position : IEquatable<Position>
	{
		public int row;
		public int col;

		public Position()
		{
			row = -1;
			col = -1;
		}

		public Position(int _row, int _col)
		{
			row = _row;
			col = _col;
		}

		public Position(Position pos)
		{
			row = pos.row;
			col = pos.col;
		}

		public bool IsValid()
		{
			return (row >= 0 && row < GameModel.NUM_ROWS && col >= 0 && col < GameModel.NUM_COLS);
		}

		public bool Equals(Position other)
		{
			return (this.row == other.row && this.col == other.col);
		}

		public override string ToString()
		{
			return ("(" + row + "," + col + ")");
		}

		public static Position operator +(Position lhs, Position rhs)
		{
			return new Position(lhs.row + rhs.row, lhs.col + rhs.col);
		}

		public static Position operator -(Position lhs, Position rhs)
		{
			return new Position(lhs.row - rhs.row, lhs.col - rhs.col);
		}
	}
}
